#include <stdlib.h>
#include <string.h>
#include "good.h"
#include "readField.h"

Boolean readGoodFromTxt(FILE *f, Good *g)
{
	Boolean ok;
	int weight;

	ok = readField(g->name, ';', f) == ';';
	ok = ok && fscanf(f, "%d;", &weight) == 1;
	if (ok)
	{
		g->weight = weight;
	}
	ok = ok && readField(g->departurePort, ';', f) == ';';
	if (ok)
	{
		readField(g->arrivalPort, '\n', f);
	}
	return ok;
}

Good* readGoodsFromTxt(FILE *f, int *dim)
{
	Good tempGood;
	Good *result;
	int goodIdx, goodCount = 0;
	while (readGoodFromTxt(f, &tempGood))
	{
		goodCount++;
	}
	fseek(f, 0, SEEK_SET); //SEEK_SET costante definita in stdio.h --> SEEK_SET == 0, indica l'inizio del file
	result = (Good*)malloc(sizeof(Good) * goodCount);
	for (goodIdx = 0; goodIdx < goodCount; goodIdx++)
	{
		readGoodFromTxt(f, &tempGood);
		result[goodIdx] = tempGood;
	}
	*dim = goodCount;
	return result;
}

void printGood(Good g)
{
	printf("Name: %s; Weight: %d; From: %s; To: %s\n", g.name, g.weight, g.departurePort, g.arrivalPort);
}

void printGoods(Good goods[], int dim)
{
	int i;
	for (i = 0; i < dim; i++)
	{
		printGood(goods[i]);
	}
}

void printShipsWithGoods(ShipList ships, Good goods[], int dim)
{
	while (ships != NULL)
	{
		int i, capacity;
		Ship currentShip = ships->ship;

		printShip(currentShip);
		for (i = 0, capacity = 0; i < dim && capacity < currentShip.capacity; i++)
		{
			if (strcmp(currentShip.departurePort, goods[i].departurePort) == 0 && 
				strcmp(currentShip.arrivalPort, goods[i].arrivalPort) == 0)
			{
				capacity += goods[i].weight;
				if (capacity < currentShip.capacity)
				{
					printGood(goods[i]);
				}
			}
		}
		printf("\n");
		ships = ships->next;
	}
}
