#include <stdlib.h>
#include <string.h>
#include "ship.h"
#include "time.h"
#include "readField.h"

ShipList addToShipList(Ship s, ShipList list)
{
	ShipList newHead = (ShipList)malloc(sizeof(ShipListElement));
	newHead->ship = s;
	newHead->next = list;
	return newHead;
}

Boolean readShipFromTxt(FILE *f, Ship *ship)
{
	Boolean ok;
	int capacity;
	int day, month, year, hour, minute, gmtOffset;

	ok = readField(ship->name, ';', f) == ';';

	ok = ok && fscanf(f, "%d;", &capacity) == 1;
	if (ok)
	{
		ship->capacity = capacity;
	}

	ok = ok && readField(ship->departurePort, ';', f) == ';';
	ok = ok && fscanf(f, "%d/%d/%dT%d:%d%d;", &day, &month, &year, &hour, &minute, &gmtOffset) == 6;
	ok = ok && fillDateTime(day, month, year, hour, minute, gmtOffset, &ship->departureTime);

	ok = ok && readField(ship->arrivalPort, ';', f) == ';';
	ok = ok && fscanf(f, "%d/%d/%dT%d:%d%d", &day, &month, &year, &hour, &minute, &gmtOffset) == 6;
	fgetc(f);	//Mangia il terminatore di linea (qualunque esso sia: \n o EOF)
	ok = ok && fillDateTime(day, month, year, hour, minute, gmtOffset, &ship->arrivalTime);
	return ok;
}

ShipList readShipsFromTxt(FILE *f)
{
	Ship temp;
	ShipList shipList = NULL;
	while (readShipFromTxt(f, &temp))
	{
		shipList = addToShipList(temp, shipList);
	}
	return shipList;
}

void printShip(Ship ship)
{
	TimeSpan durationTimeSpan;
	char departureDateTime[50], arrivalDateTime[50], duration[30];

	dateTimeToString(ship.departureTime, departureDateTime);
	dateTimeToString(ship.arrivalTime, arrivalDateTime);
	durationTimeSpan = dateTimeDifference(ship.arrivalTime, ship.departureTime);
	timeSpanToString(durationTimeSpan, duration);

	printf("Name: %s -- Capacity: %d\nFrom: %s -- %s\nTo: %s -- %s\nDuration: %s\n", 
		ship.name, ship.capacity,
		ship.departurePort, departureDateTime,
		ship.arrivalPort, arrivalDateTime,
		duration);
}

void printShips(ShipList ships)
{	
	while (ships != NULL)
	{
		printShip(ships->ship);
		ships = ships->next;
	}
}
