#include <stdio.h>
#include "boolean.h"
#include "time.h"

#ifndef SHIP
#define SHIP

typedef char ShipName[17];
typedef char PortName[17];

typedef struct ShipStruct
{
	ShipName name;
	int capacity;
	PortName departurePort;
	DateTime departureTime;
	PortName arrivalPort;	
	DateTime arrivalTime;
} Ship;

typedef struct ShipListElementStruct
{
	Ship ship;
	struct ShipListElementStruct *next;
} ShipListElement;

typedef ShipListElement *ShipList;

#endif

ShipList addToShipList(Ship s, ShipList list);

Boolean readShipFromTxt(FILE *f, Ship *ship);

ShipList readShipsFromTxt(FILE *f);

void printShip(Ship ship);
void printShips(ShipList ships);
